/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of EV.xs. Do not edit this file, edit EV.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "EV.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/*#include <netinet/in.h>*/

/* fix perl api breakage */
#undef signal
#undef sigaction

#define EV_PROTOTYPES 1
#define EV_USE_NANOSLEEP EV_USE_MONOTONIC
#define EV_H <ev.h>
#include "EV/EVAPI.h"

#define EV_SELECT_IS_WINSOCKET 0
#ifdef _WIN32
# define EV_SELECT_USE_FD_SET 0
# define NFDBITS PERL_NFDBITS
# define fd_mask Perl_fd_mask
#endif
/* due to bugs in OS X we have to use libev/ explicitly here */
#include "libev/ev.c"

#ifndef _WIN32
# include <pthread.h>
#endif

/* 5.10.0 */
#ifndef SvREFCNT_inc_NN
# define SvREFCNT_inc_NN(sv) SvREFCNT_inc (sv)
#endif

/* 5.6.x */
#ifndef SvRV_set
# define SvRV_set(a,b) SvRV ((a)) = (b)
#endif

#if __GNUC__ >= 3
# define expect(expr,value) __builtin_expect ((expr),(value))
#else
# define expect(expr,value) (expr)
#endif

#define expect_false(expr) expect ((expr) != 0, 0)
#define expect_true(expr)  expect ((expr) != 0, 1)

#define e_loop(w) INT2PTR (struct ev_loop *, SvIVX ((w)->loop))

#define WFLAG_KEEPALIVE 1
#define WFLAG_UNREFED   2 /* has been unref'ed */

#define UNREF(w)				\
  if (!((w)->e_flags & (WFLAG_KEEPALIVE | WFLAG_UNREFED))	\
      && ev_is_active (w))			\
    {						\
      ev_unref (e_loop (w));			\
      (w)->e_flags |= WFLAG_UNREFED;		\
    }

#define REF(w)					\
  if ((w)->e_flags & WFLAG_UNREFED)		\
    {						\
      (w)->e_flags &= ~WFLAG_UNREFED;		\
      ev_ref (e_loop (w));			\
    }

#define START(type,w)				\
  do {						\
    ev_ ## type ## _start (e_loop (w), w);	\
    UNREF (w);					\
  } while (0)

#define STOP(type,w)				\
  do {						\
    REF (w);					\
    ev_ ## type ## _stop (e_loop (w), w);	\
  } while (0)

#define RESET(type,w,seta)			\
 do {                                           \
   int active = ev_is_active (w);               \
   if (active) STOP (type, w);                  \
   ev_ ## type ## _set seta;                    \
   if (active) START (type, w);                 \
 } while (0)

typedef int Signal;

static SV *default_loop_sv;

static struct EVAPI evapi;

static HV
  *stash_loop,
  *stash_watcher,
  *stash_io,
  *stash_timer,
  *stash_periodic,
  *stash_signal,
  *stash_child,
  *stash_stat,
  *stash_idle,
  *stash_prepare,
  *stash_check,
  *stash_embed,
  *stash_fork,
  *stash_async;

#ifndef SIG_SIZE
/* kudos to Slaven Rezic for the idea */
static char sig_size [] = { SIG_NUM };
# define SIG_SIZE (sizeof (sig_size) + 1)
#endif

static Signal
sv_signum (SV *sig)
{
  Signal signum;

  SvGETMAGIC (sig);

  for (signum = 1; signum < SIG_SIZE; ++signum)
    if (strEQ (SvPV_nolen (sig), PL_sig_name [signum]))
      return signum;

  signum = SvIV (sig);

  if (signum > 0 && signum < SIG_SIZE)
    return signum;

  return -1;
}

/////////////////////////////////////////////////////////////////////////////
// Event

static void e_cb (EV_P_ ev_watcher *w, int revents);

static int
sv_fileno (SV *fh)
{
  SvGETMAGIC (fh);

  if (SvROK (fh))
    fh = SvRV (fh);

  if (SvTYPE (fh) == SVt_PVGV)
    return PerlIO_fileno (IoIFP (sv_2io (fh)));

  if (SvOK (fh) && (SvIV (fh) >= 0) && (SvIV (fh) < 0x7fffffffL))
    return SvIV (fh);

  return -1;
}

static SV *
e_get_cv (SV *cb_sv)
{
  HV *st;
  GV *gvp;
  CV *cv = sv_2cv (cb_sv, &st, &gvp, 0);

  if (!cv)
    croak ("EV watcher callback must be a CODE reference");

  return (SV *)cv;
}

static void *
e_new (int size, SV *cb_sv, SV *loop)
{
  SV *cv = cb_sv ? e_get_cv (cb_sv) : 0;
  ev_watcher *w;
  SV *self = NEWSV (0, size);
  SvPOK_only (self);
  SvCUR_set (self, size);

  w = (ev_watcher *)SvPVX (self);

  ev_init (w, cv ? e_cb : 0);

  w->loop    = SvREFCNT_inc (SvRV (loop));
  w->e_flags = WFLAG_KEEPALIVE;
  w->data    = 0;
  w->fh      = 0;
  w->cb_sv   = SvREFCNT_inc (cv);
  w->self    = self;

  return (void *)w;
}

static void
e_destroy (void *w_)
{
  ev_watcher *w = (ev_watcher *)w_;

  SvREFCNT_dec (w->loop ); w->loop  = 0;
  SvREFCNT_dec (w->fh   ); w->fh    = 0;
  SvREFCNT_dec (w->cb_sv); w->cb_sv = 0;
  SvREFCNT_dec (w->data ); w->data  = 0;
}

static SV *
e_bless (ev_watcher *w, HV *stash)
{
  SV *rv;

  if (SvOBJECT (w->self))
    rv = newRV_inc (w->self);
  else
    {
      rv = newRV_noinc (w->self);
      sv_bless (rv, stash);
      SvREADONLY_on (w->self);
    }

  return rv;
}

static SV *sv_self_cache, *sv_events_cache;

static void
e_cb (EV_P_ ev_watcher *w, int revents)
{
  dSP;
  I32 mark = SP - PL_stack_base;
  SV *sv_self, *sv_events;

  /* libev might have stopped the watcher */
  if (expect_false (w->e_flags & WFLAG_UNREFED)
      && !ev_is_active (w))
    REF (w);

  if (expect_true (sv_self_cache))
    {
      sv_self = sv_self_cache; sv_self_cache = 0;
      SvRV_set (sv_self, SvREFCNT_inc_NN (w->self));
    }
  else
    {
      sv_self = newRV_inc (w->self); /* w->self MUST be blessed by now */
      SvREADONLY_on (sv_self);
    }

  if (expect_true (sv_events_cache))
    {
      sv_events = sv_events_cache; sv_events_cache = 0;
      SvIV_set (sv_events, revents);
    }
  else
    {
      sv_events = newSViv (revents);
      SvREADONLY_on (sv_events);
    }

  PUSHMARK (SP);
  EXTEND (SP, 2);
  PUSHs (sv_self);
  PUSHs (sv_events);

  PUTBACK;
  call_sv (w->cb_sv, G_DISCARD | G_VOID | G_EVAL);

  if (expect_false (SvREFCNT (sv_self) != 1 || sv_self_cache))
    SvREFCNT_dec (sv_self);
  else
    {
      SvREFCNT_dec (SvRV (sv_self));
      SvRV_set (sv_self, &PL_sv_undef);
      sv_self_cache = sv_self;
    }

  if (expect_false (SvREFCNT (sv_events) != 1 || sv_events_cache))
    SvREFCNT_dec (sv_events);
  else
    sv_events_cache = sv_events;

  if (expect_false (SvTRUE (ERRSV)))
    {
      SPAGAIN;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
    }

  SP = PL_stack_base + mark;
  PUTBACK;
}

static void
e_once_cb (int revents, void *arg)
{
  dSP;
  I32 mark = SP - PL_stack_base;
  SV *sv_events;

  if (sv_events_cache)
    {
      sv_events = sv_events_cache; sv_events_cache = 0;
      SvIV_set (sv_events, revents);
    }
  else
    sv_events = newSViv (revents);

  PUSHMARK (SP);
  XPUSHs (sv_events);

  PUTBACK;
  call_sv ((SV *)arg, G_DISCARD | G_VOID | G_EVAL);

  SvREFCNT_dec ((SV *)arg);

  if (sv_events_cache)
    SvREFCNT_dec (sv_events);
  else
    sv_events_cache = sv_events;

  if (SvTRUE (ERRSV))
    {
      SPAGAIN;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
    }

  SP = PL_stack_base + mark;
  PUTBACK;
}

static ev_tstamp
e_periodic_cb (ev_periodic *w, ev_tstamp now)
{
  ev_tstamp retval;
  int count;
  dSP;

  ENTER;
  SAVETMPS;

  PUSHMARK (SP);
  EXTEND (SP, 2);
  PUSHs (newRV_inc (w->self)); /* w->self MUST be blessed by now */
  PUSHs (newSVnv (now));

  PUTBACK;
  count = call_sv (w->fh, G_SCALAR | G_EVAL);
  SPAGAIN;

  if (SvTRUE (ERRSV))
    {
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
      SPAGAIN;
    }

  if (count > 0)
    {
      retval = SvNV (TOPs);

      if (retval < now)
        retval = now;
    }
  else
    retval = now;

  FREETMPS;
  LEAVE;

  return retval;
}

#define CHECK_REPEAT(repeat) if (repeat < 0.) \
  croak (# repeat " value must be >= 0");

#define CHECK_FD(fh,fd) if ((fd) < 0) \
  croak ("illegal file descriptor or filehandle (either no attached file descriptor or illegal value): %s", SvPV_nolen (fh));

#define CHECK_SIG(sv,num) if ((num) < 0) \
  croak ("illegal signal number or name: %s", SvPV_nolen (sv));

/////////////////////////////////////////////////////////////////////////////
// XS interface functions

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 400 "EV.c"

XS(XS_EV_default_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_default_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::default_loop", "flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	unsigned int	flags;

	if (items < 1)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(0));
	}
#line 530 "EV.xs"
{
	if (!default_loop_sv)
          {
            evapi.default_loop = ev_default_loop (flags);

            if (!evapi.default_loop)
              XSRETURN_UNDEF;

            default_loop_sv = sv_bless (newRV_noinc (newSViv (PTR2IV (evapi.default_loop))), stash_loop);
          }

        RETVAL = newSVsv (default_loop_sv);
}
#line 436 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_default_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_default_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::default_destroy", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 548 "EV.xs"
        ev_default_destroy ();
        SvREFCNT_dec (default_loop_sv);
        default_loop_sv = 0;
#line 460 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_supported_backends); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_supported_backends)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::supported_backends", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_supported_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_recommended_backends); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_recommended_backends)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::recommended_backends", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_recommended_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_embeddable_backends); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_embeddable_backends)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::embeddable_backends", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_embeddable_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_sleep); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_sleep)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::sleep", "interval");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	interval = (NV)SvNV(ST(0));

	ev_sleep(interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::time", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	RETVAL;
	dXSTARG;

	RETVAL = ev_time();
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_now); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_now)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::now", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	RETVAL;
	dXSTARG;

	RETVAL = ev_now(evapi.default_loop);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_now_update); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_now_update)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::now_update", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {

	ev_now_update(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::suspend", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {

	ev_suspend(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::resume", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {

	ev_resume(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_backend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_backend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::backend", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_backend(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_loop_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_loop_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::loop_count", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_loop_count(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV_set_io_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_set_io_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::set_io_collect_interval", "interval");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	interval = (NV)SvNV(ST(0));

	ev_set_io_collect_interval(evapi.default_loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_set_timeout_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_set_timeout_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::set_timeout_collect_interval", "interval");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	interval = (NV)SvNV(ST(0));

	ev_set_timeout_collect_interval(evapi.default_loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::loop", "flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;

	if (items < 1)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(0));
	}

	ev_loop(evapi.default_loop, flags);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_unloop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_unloop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::unloop", "how= EVUNLOOP_ONE");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	how;

	if (items < 1)
	    how = EVUNLOOP_ONE;
	else {
	    how = (int)SvIV(ST(0));
	}

	ev_unloop(evapi.default_loop, how);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_feed_fd_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_feed_fd_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::feed_fd_event", "fd, revents= EV_NONE");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	fd = (int)SvIV(ST(0));
	int	revents;

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1));
	}

	ev_feed_fd_event(evapi.default_loop, fd, revents);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_feed_signal_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_feed_signal_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::feed_signal_event", "signal");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	signal = ST(0);
#line 597 "EV.xs"
{
  	Signal signum = sv_signum (signal);
        CHECK_SIG (signal, signum);

        ev_feed_signal_event (evapi.default_loop, signum);
}
#line 836 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV_io); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_io)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "fh, events, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_io *	RETVAL;
	SV *	fh = ST(0);
	int	events = (int)SvIV(ST(1));
	SV *	cb = ST(2);
#line 608 "EV.xs"
{
	int fd = sv_fileno (fh);
        CHECK_FD (fh, fd);

        RETVAL = e_new (sizeof (ev_io), cb, default_loop_sv);
        RETVAL->fh = newSVsv (fh);
        ev_io_set (RETVAL, fd, events);
        if (!ix) START (io, RETVAL);
}
#line 869 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_io);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_timer); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_timer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "after, repeat, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_timer *	RETVAL;
	NV	after = (NV)SvNV(ST(0));
	NV	repeat = (NV)SvNV(ST(1));
	SV *	cb = ST(2);
#line 624 "EV.xs"
        CHECK_REPEAT (repeat);
#line 898 "EV.c"
#line 626 "EV.xs"
        RETVAL = e_new (sizeof (ev_timer), cb, default_loop_sv);
        ev_timer_set (RETVAL, after, repeat);
        if (!ix) START (timer, RETVAL);
#line 903 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_timer);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_periodic); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_periodic)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "at, interval, reschedule_cb, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	NV	at = (NV)SvNV(ST(0));
	NV	interval = (NV)SvNV(ST(1));
	SV *	reschedule_cb = ST(2);
	SV *	cb = ST(3);
#line 636 "EV.xs"
        CHECK_REPEAT (interval);
#line 933 "EV.c"
#line 638 "EV.xs"
{
  	ev_periodic *w;
        w = e_new (sizeof (ev_periodic), cb, default_loop_sv);
        w->fh = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;
        ev_periodic_set (w, at, interval, w->fh ? e_periodic_cb : 0);
        RETVAL = e_bless ((ev_watcher *)w, stash_periodic);
        if (!ix) START (periodic, w);
}
#line 943 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "signal, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_signal *	RETVAL;
	SV *	signal = ST(0);
	SV *	cb = ST(1);
#line 653 "EV.xs"
{
  	Signal signum = sv_signum (signal);
        CHECK_SIG (signal, signum);

        RETVAL = e_new (sizeof (ev_signal), cb, default_loop_sv);
        ev_signal_set (RETVAL, signum);
        if (!ix) START (signal, RETVAL);
}
#line 976 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_signal);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_idle); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_idle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_idle *	RETVAL;
	SV *	cb = ST(0);
#line 668 "EV.xs"
        RETVAL = e_new (sizeof (ev_idle), cb, default_loop_sv);
        ev_idle_set (RETVAL);
        if (!ix) START (idle, RETVAL);
#line 1005 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_idle);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_prepare); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_prepare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_prepare *	RETVAL;
	SV *	cb = ST(0);
#line 678 "EV.xs"
        RETVAL = e_new (sizeof (ev_prepare), cb, default_loop_sv);
        ev_prepare_set (RETVAL);
        if (!ix) START (prepare, RETVAL);
#line 1034 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_prepare);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_check *	RETVAL;
	SV *	cb = ST(0);
#line 688 "EV.xs"
        RETVAL = e_new (sizeof (ev_check), cb, default_loop_sv);
        ev_check_set (RETVAL);
        if (!ix) START (check, RETVAL);
#line 1063 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_check);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_fork); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_fork)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_fork *	RETVAL;
	SV *	cb = ST(0);
#line 698 "EV.xs"
        RETVAL = e_new (sizeof (ev_fork), cb, default_loop_sv);
        ev_fork_set (RETVAL);
        if (!ix) START (fork, RETVAL);
#line 1092 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_fork);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_child); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_child)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "pid, trace, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_child *	RETVAL;
	int	pid = (int)SvIV(ST(0));
	int	trace = (int)SvIV(ST(1));
	SV *	cb = ST(2);
#line 708 "EV.xs"
        RETVAL = e_new (sizeof (ev_child), cb, default_loop_sv);
        ev_child_set (RETVAL, pid, trace);
        if (!ix) START (child, RETVAL);
#line 1123 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_child);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "path, interval, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_stat *	RETVAL;
	SV *	path = ST(0);
	NV	interval = (NV)SvNV(ST(1));
	SV *	cb = ST(2);
#line 718 "EV.xs"
        RETVAL = e_new (sizeof (ev_stat), cb, default_loop_sv);
        RETVAL->fh = newSVsv (path);
        ev_stat_set (RETVAL, SvPVbyte_nolen (RETVAL->fh), interval);
        if (!ix) START (stat, RETVAL);
#line 1155 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_stat);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_embed); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_embed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, cb= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_embed *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 2)
	    cb = 0;
	else {
	    cb = ST(1);
	}
#line 729 "EV.xs"
{
        if (!(ev_backend (loop) & ev_embeddable_backends ()))
          croak ("passed loop is not embeddable via EV::embed,");

        RETVAL = e_new (sizeof (ev_embed), cb, default_loop_sv);
        RETVAL->fh = newSVsv (ST (0));
        ev_embed_set (RETVAL, loop);
        if (!ix) START (embed, RETVAL);
}
#line 1202 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_embed);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_async); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_async)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_async *	RETVAL;
	SV *	cb = ST(0);
#line 745 "EV.xs"
        RETVAL = e_new (sizeof (ev_async), cb, default_loop_sv);
        ev_async_set (RETVAL);
        if (!ix) START (async, RETVAL);
#line 1231 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_async);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV_once); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV_once)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::once", "fh, events, timeout, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	fh = ST(0);
	int	events = (int)SvIV(ST(1));
	SV *	timeout = ST(2);
	SV *	cb = ST(3);
#line 753 "EV.xs"
        ev_once (
           evapi.default_loop,
           sv_fileno (fh), events,
           SvOK (timeout) ? SvNV (timeout) : -1.,
           e_once_cb,
           newSVsv (cb)
        );
#line 1265 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Watcher_is_active); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_is_active)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::is_active", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	RETVAL = ev_is_active(w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_is_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_is_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::is_pending", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	RETVAL = ev_is_pending(w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_invoke); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_invoke)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::invoke", "w, revents= EV_NONE");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_watcher *	w;
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1));
	}

	ev_invoke(e_loop (w), w, revents);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Watcher_clear_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_clear_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::clear_pending", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	RETVAL = ev_clear_pending(e_loop (w), w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_feed_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_feed_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::feed_event", "w, revents= EV_NONE");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_watcher *	w;
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1));
	}

	ev_feed_event(e_loop (w), w, revents);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Watcher_keepalive); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_keepalive)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::keepalive", "w, new_value= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;
	int	new_value;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_value = 0;
	else {
	    new_value = (int)SvIV(ST(1));
	}
#line 780 "EV.xs"
{
        RETVAL = w->e_flags & WFLAG_KEEPALIVE;
        new_value = new_value ? WFLAG_KEEPALIVE : 0;

        if (items > 1 && ((new_value ^ w->e_flags) & WFLAG_KEEPALIVE))
          {
            w->e_flags = (w->e_flags & ~WFLAG_KEEPALIVE) | new_value;
            REF (w);
            UNREF (w);
          }
}
#line 1464 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::cb", "w, new_cb= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	ev_watcher *	w;
	SV *	new_cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_cb = 0;
	else {
	    new_cb = ST(1);
	}
#line 796 "EV.xs"
{
        if (items > 1)
          {
            new_cb = e_get_cv (new_cb);
            RETVAL = newRV_noinc (w->cb_sv);
            w->cb_sv = SvREFCNT_inc (new_cb);
          }
        else
          RETVAL = newRV_inc (w->cb_sv);
}
#line 1509 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::data", "w, new_data= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	ev_watcher *	w;
	SV *	new_data;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_data = 0;
	else {
	    new_data = ST(1);
	}
#line 811 "EV.xs"
{
	RETVAL = w->data ? newSVsv (w->data) : &PL_sv_undef;

        if (items > 1)
          {
            SvREFCNT_dec (w->data);
            w->data = newSVsv (new_data);
          }
}
#line 1554 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::loop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));
#line 825 "EV.xs"
	RETVAL = newRV_inc (w->loop);
#line 1584 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Watcher_priority); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Watcher_priority)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Watcher::priority", "w, new_priority= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;
	int	new_priority;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_priority = 0;
	else {
	    new_priority = (int)SvIV(ST(1));
	}
#line 831 "EV.xs"
{
        RETVAL = w->priority;

        if (items > 1)
          {
            int active = ev_is_active (w);

            if (active)
              {
                /* grrr. */
                PUSHMARK (SP);
                XPUSHs (ST (0));
                PUTBACK;
                call_method ("stop", G_DISCARD | G_VOID);
              }

            ev_set_priority (w, new_priority);

            if (active)
              {
                PUSHMARK (SP);
                XPUSHs (ST (0));
                PUTBACK;
                call_method ("start", G_DISCARD | G_VOID);
              }
          }
}
#line 1648 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__IO_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::IO::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 865 "EV.xs"
        START (io, w);
#line 1676 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::IO::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 869 "EV.xs"
        STOP (io, w);
#line 1703 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::IO::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 873 "EV.xs"
        STOP (io, w);
        e_destroy (w);
#line 1731 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::IO::set", "w, fh, events");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_io *	w;
	SV *	fh = ST(1);
	int	events = (int)SvIV(ST(2));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));
#line 878 "EV.xs"
{
	int fd = sv_fileno (fh);
        CHECK_FD (fh, fd);

        sv_setsv (w->fh, fh);
        RESET (io, w, (w, fd, events));
}
#line 1766 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__IO_fh); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_fh)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::IO::fh", "w, new_fh= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	ev_io *	w;
	SV *	new_fh;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_fh = 0;
	else {
	    new_fh = ST(1);
	}
#line 888 "EV.xs"
{
        if (items > 1)
          {
            int fd = sv_fileno (new_fh);
            CHECK_FD (new_fh, fd);

            RETVAL = w->fh;
            w->fh = newSVsv (new_fh);

            RESET (io, w, (w, fd, w->events));
          }
        else
          RETVAL = newSVsv (w->fh);
}
#line 1814 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__IO_events); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__IO_events)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::IO::events", "w, new_events= EV_UNDEF");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_io *	w;
	int	new_events;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_events = EV_UNDEF;
	else {
	    new_events = (int)SvIV(ST(1));
	}
#line 907 "EV.xs"
{
        RETVAL = w->events;

        if (items > 1)
          RESET (io, w, (w, w->fd, new_events));
}
#line 1857 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Signal_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Signal::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 920 "EV.xs"
        START (signal, w);
#line 1885 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Signal::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 924 "EV.xs"
        STOP (signal, w);
#line 1912 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Signal::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 928 "EV.xs"
        STOP (signal, w);
        e_destroy (w);
#line 1940 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Signal::set", "w, signal");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_signal *	w;
	SV *	signal = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));
#line 933 "EV.xs"
{
	Signal signum = sv_signum (signal);
        CHECK_SIG (signal, signum);

        RESET (signal, w, (w, signum));
}
#line 1973 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Signal_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Signal_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Signal::signal", "w, new_signal= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_signal *	w;
	SV *	new_signal;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_signal = 0;
	else {
	    new_signal = ST(1);
	}
#line 942 "EV.xs"
{
        RETVAL = w->signum;

        if (items > 1)
          {
            Signal signum = sv_signum (new_signal);
            CHECK_SIG (new_signal, signum);

            RESET (signal, w, (w, signum));
          }
}
#line 2019 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Timer_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Timer::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 960 "EV.xs"
        CHECK_REPEAT (w->repeat);
#line 2047 "EV.c"
#line 962 "EV.xs"
        START (timer, w);
#line 2050 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Timer::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 966 "EV.xs"
        STOP (timer, w);
#line 2077 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_again); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_again)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Timer::again", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 970 "EV.xs"
        CHECK_REPEAT (w->repeat);
#line 2104 "EV.c"
#line 972 "EV.xs"
        ev_timer_again (e_loop (w), w);
        UNREF (w);
#line 2108 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Timer::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));
#line 977 "EV.xs"
        STOP (timer, w);
        e_destroy (w);
#line 2136 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Timer_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Timer_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Timer::set", "w, after, repeat= 0.");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_timer *	w;
	NV	after = (NV)SvNV(ST(1));
	NV	repeat;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)));

	if (items < 3)
	    repeat = 0.;
	else {
	    repeat = (NV)SvNV(ST(2));
	}
#line 982 "EV.xs"
        CHECK_REPEAT (repeat);
#line 2171 "EV.c"
#line 984 "EV.xs"
        RESET (timer, w, (w, after, repeat));
#line 2174 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Periodic::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 990 "EV.xs"
        CHECK_REPEAT (w->interval);
#line 2201 "EV.c"
#line 992 "EV.xs"
        START (periodic, w);
#line 2204 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Periodic::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 996 "EV.xs"
        STOP (periodic, w);
#line 2231 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_again); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_again)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Periodic::again", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 1000 "EV.xs"
        ev_periodic_again (e_loop (w), w);
        UNREF (w);
#line 2259 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Periodic::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 1005 "EV.xs"
        STOP (periodic, w);
        e_destroy (w);
#line 2287 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Periodic::set", "w, at, interval= 0., reschedule_cb= &PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_periodic *	w;
	NV	at = (NV)SvNV(ST(1));
	NV	interval;
	SV *	reschedule_cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));

	if (items < 3)
	    interval = 0.;
	else {
	    interval = (NV)SvNV(ST(2));
	}

	if (items < 4)
	    reschedule_cb = &PL_sv_undef;
	else {
	    reschedule_cb = ST(3);
	}
#line 1010 "EV.xs"
        CHECK_REPEAT (interval);
#line 2329 "EV.c"
#line 1012 "EV.xs"
{
        SvREFCNT_dec (w->fh);
        w->fh = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;

        RESET (periodic, w, (w, at, interval, w->fh ? e_periodic_cb : 0));
}
#line 2337 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Periodic_at); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Periodic_at)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Periodic::at", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	RETVAL;
	dXSTARG;
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)));
#line 1021 "EV.xs"
        RETVAL = ev_periodic_at (w);
#line 2366 "EV.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Idle_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Idle_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Idle::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)));
#line 1029 "EV.xs"
        START (idle, w);
#line 2394 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Idle_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Idle_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Idle::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)));
#line 1033 "EV.xs"
        STOP (idle, w);
#line 2421 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Idle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Idle_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Idle::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)));
#line 1037 "EV.xs"
        STOP (idle, w);
        e_destroy (w);
#line 2449 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Prepare_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Prepare_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Prepare::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)));
#line 1044 "EV.xs"
        START (prepare, w);
#line 2476 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Prepare_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Prepare_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Prepare::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)));
#line 1048 "EV.xs"
        STOP (prepare, w);
#line 2503 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Prepare_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Prepare_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Prepare::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)));
#line 1052 "EV.xs"
        STOP (prepare, w);
        e_destroy (w);
#line 2531 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Check_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Check_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Check::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)));
#line 1059 "EV.xs"
        START (check, w);
#line 2558 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Check_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Check_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Check::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)));
#line 1063 "EV.xs"
        STOP (check, w);
#line 2585 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Check_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Check_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Check::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)));
#line 1067 "EV.xs"
        STOP (check, w);
        e_destroy (w);
#line 2613 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Fork_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Fork_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Fork::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)));
#line 1074 "EV.xs"
        START (fork, w);
#line 2640 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Fork_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Fork_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Fork::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)));
#line 1078 "EV.xs"
        STOP (fork, w);
#line 2667 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Fork_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Fork_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Fork::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)));
#line 1082 "EV.xs"
        STOP (fork, w);
        e_destroy (w);
#line 2695 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Child::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1089 "EV.xs"
        START (child, w);
#line 2722 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Child::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1093 "EV.xs"
        STOP (child, w);
#line 2749 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Child::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1097 "EV.xs"
        STOP (child, w);
        e_destroy (w);
#line 2777 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Child::set", "w, pid, trace");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_child *	w;
	int	pid = (int)SvIV(ST(1));
	int	trace = (int)SvIV(ST(2));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1102 "EV.xs"
        RESET (child, w, (w, pid, trace));
#line 2806 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Child_pid); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Child_pid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)));
#line 1109 "EV.xs"
        RETVAL = ix == 0 ? w->pid
               : ix == 1 ? w->rpid
               :           w->rstatus;
#line 2838 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Stat_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Stat::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1119 "EV.xs"
        START (stat, w);
#line 2866 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Stat::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1123 "EV.xs"
        STOP (stat, w);
#line 2893 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Stat::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1127 "EV.xs"
        STOP (stat, w);
        e_destroy (w);
#line 2921 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Stat::set", "w, path, interval");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_stat *	w;
	SV *	path = ST(1);
	NV	interval = (NV)SvNV(ST(2));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1132 "EV.xs"
{
        sv_setsv (w->fh, path);
	RESET (stat, w, (w, SvPVbyte_nolen (w->fh), interval));
}
#line 2953 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Stat_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Stat::path", "w, new_path= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	ev_stat *	w;
	SV *	new_path;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_path = 0;
	else {
	    new_path = ST(1);
	}
#line 1139 "EV.xs"
{
        RETVAL = SvREFCNT_inc (w->fh);

        if (items > 1)
          {
            SvREFCNT_dec (w->fh);
            w->fh = newSVsv (new_path);
            RESET (stat, w, (w, SvPVbyte_nolen (w->fh), w->interval));
          }
}
#line 2997 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Stat_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Stat::interval", "w, new_interval= 0.");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	RETVAL;
	dXSTARG;
	ev_stat *	w;
	NV	new_interval;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));

	if (items < 2)
	    new_interval = 0.;
	else {
	    new_interval = (NV)SvNV(ST(1));
	}
#line 1154 "EV.xs"
{
        RETVAL = w->interval;

        if (items > 1)
          RESET (stat, w, (w, SvPVbyte_nolen (w->fh), new_interval));
}
#line 3040 "EV.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Stat_prev); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Stat_prev)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "w");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)));
#line 1168 "EV.xs"
{
	ev_statdata *s = ix ? &w->attr : &w->prev;

        if (ix == 1)
          ev_stat_stat (e_loop (w), w);
        else if (!s->st_nlink)
          errno = ENOENT;

        PL_statcache.st_dev   = s->st_nlink;
        PL_statcache.st_ino   = s->st_ino;
        PL_statcache.st_mode  = s->st_mode;
        PL_statcache.st_nlink = s->st_nlink;
        PL_statcache.st_uid   = s->st_uid;
        PL_statcache.st_gid   = s->st_gid;
        PL_statcache.st_rdev  = s->st_rdev;
        PL_statcache.st_size  = s->st_size;
        PL_statcache.st_atime = s->st_atime;
        PL_statcache.st_mtime = s->st_mtime;
        PL_statcache.st_ctime = s->st_ctime;

        if (GIMME_V == G_SCALAR)
          XPUSHs (boolSV (s->st_nlink));
        else if (GIMME_V == G_ARRAY && s->st_nlink)
          {
            EXTEND (SP, 13);
            PUSHs (sv_2mortal (newSViv (s->st_dev)));
            PUSHs (sv_2mortal (newSViv (s->st_ino)));
            PUSHs (sv_2mortal (newSVuv (s->st_mode)));
            PUSHs (sv_2mortal (newSVuv (s->st_nlink)));
            PUSHs (sv_2mortal (newSViv (s->st_uid)));
            PUSHs (sv_2mortal (newSViv (s->st_gid)));
            PUSHs (sv_2mortal (newSViv (s->st_rdev)));
            PUSHs (sv_2mortal (newSVnv ((NV)s->st_size)));
            PUSHs (sv_2mortal (newSVnv (s->st_atime)));
            PUSHs (sv_2mortal (newSVnv (s->st_mtime)));
            PUSHs (sv_2mortal (newSVnv (s->st_ctime)));
            PUSHs (sv_2mortal (newSVuv (4096)));
            PUSHs (sv_2mortal (newSVnv ((NV)((s->st_size + 4095) / 4096))));
          }
}
#line 3110 "EV.c"
	PUTBACK;
	return;
    }
}


XS(XS_EV__Embed_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Embed::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1213 "EV.xs"
        START (embed, w);
#line 3138 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Embed::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1217 "EV.xs"
        STOP (embed, w);
#line 3165 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Embed::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1221 "EV.xs"
        STOP (embed, w);
        e_destroy (w);
#line 3193 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Embed::set", "w, loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_embed *	w;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));

	if (!(SvROK (ST(1)) && SvOBJECT (SvRV (ST(1)))
              && (SvSTASH (SvRV (ST(1))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(1)));
#line 1226 "EV.xs"
{
        sv_setsv (w->fh, ST (1));
	RESET (embed, w, (w, loop));
}
#line 3229 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Embed_other); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_other)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Embed::other", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));
#line 1233 "EV.xs"
        RETVAL = newSVsv (w->fh);
#line 3257 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Embed_sweep); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Embed_sweep)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Embed::sweep", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)));

	ev_embed_sweep(e_loop (w), w);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Async::start", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1244 "EV.xs"
        START (async, w);
#line 3312 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Async::stop", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1248 "EV.xs"
        STOP (async, w);
#line 3339 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Async::DESTROY", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1252 "EV.xs"
        STOP (async, w);
        e_destroy (w);
#line 3367 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_send); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_send)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Async::send", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));

	ev_async_send(e_loop (w), w);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Async_async_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Async_async_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Async::async_pending", "w");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)));
#line 1260 "EV.xs"
        RETVAL = boolSV (ev_async_pending (w));
#line 3421 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::new", "klass, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	SV *	klass = ST(0);
	unsigned int	flags;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 1268 "EV.xs"
{
	struct ev_loop *loop = ev_loop_new (flags);

        if (!loop)
          XSRETURN_UNDEF;

        RETVAL = sv_bless (newRV_noinc (newSViv (PTR2IV (loop))), stash_loop);
}
#line 3459 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::DESTROY", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1281 "EV.xs"
        if (loop != evapi.default_loop) /* global destruction sucks */
          ev_loop_destroy (loop);
#line 3488 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_loop_fork); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop_fork)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::loop_fork", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_loop_fork(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_loop_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop_verify)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::loop_verify", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_loop_verify(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_now); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_now)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::now", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	NV	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_now(loop);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_now_update); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_now_update)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::now_update", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_now_update(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::suspend", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_suspend(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::resume", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_resume(loop);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_set_io_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_set_io_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::set_io_collect_interval", "loop, interval");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;
	NV	interval = (NV)SvNV(ST(1));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_set_io_collect_interval(loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_set_timeout_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_set_timeout_collect_interval)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::set_timeout_collect_interval", "loop, interval");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;
	NV	interval = (NV)SvNV(ST(1));

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	ev_set_timeout_collect_interval(loop, interval);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_backend); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_backend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::backend", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_backend(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_loop_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::loop_count", "loop");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	RETVAL = ev_loop_count(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::loop", "loop, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;
	int	flags;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}

	ev_loop(loop, flags);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_unloop); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_unloop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::unloop", "loop, how= 1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;
	int	how;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 2)
	    how = 1;
	else {
	    how = (int)SvIV(ST(1));
	}

	ev_unloop(loop, how);
    }
    XSRETURN_EMPTY;
}


XS(XS_EV__Loop_feed_fd_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_feed_fd_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::feed_fd_event", "loop, fd, revents= EV_NONE");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;
	int	fd = (int)SvIV(ST(1));
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (items < 3)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(2));
	}

	ev_feed_fd_event(loop, fd, revents);
    }
    XSRETURN_EMPTY;
}

#if 0
#define XSubPPtmpAAAA 1


XS(XS_EV__Loop_feed_signal_event); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_feed_signal_event)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::feed_signal_event", "loop, signal");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;
	SV *	signal = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1314 "EV.xs"
{
  	Signal signum = sv_signum (signal);
        CHECK_SIG (signal, signum);

        ev_feed_signal_event (loop, signum);
}
#line 3881 "EV.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS(XS_EV__Loop_io); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_io)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, fh, events, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_io *	RETVAL;
	struct ev_loop *	loop;
	SV *	fh = ST(1);
	int	events = (int)SvIV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1327 "EV.xs"
{
	int fd = sv_fileno (fh);
        CHECK_FD (fh, fd);

        RETVAL = e_new (sizeof (ev_io), cb, ST (0));
        RETVAL->fh = newSVsv (fh);
        ev_io_set (RETVAL, fd, events);
        if (!ix) START (io, RETVAL);
}
#line 3921 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_io);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_timer); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_timer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, after, repeat, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_timer *	RETVAL;
	struct ev_loop *	loop;
	NV	after = (NV)SvNV(ST(1));
	NV	repeat = (NV)SvNV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1343 "EV.xs"
        CHECK_REPEAT (repeat);
#line 3956 "EV.c"
#line 1345 "EV.xs"
        RETVAL = e_new (sizeof (ev_timer), cb, ST (0));
        ev_timer_set (RETVAL, after, repeat);
        if (!ix) START (timer, RETVAL);
#line 3961 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_timer);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_periodic); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_periodic)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, at, interval, reschedule_cb, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	struct ev_loop *	loop;
	NV	at = (NV)SvNV(ST(1));
	NV	interval = (NV)SvNV(ST(2));
	SV *	reschedule_cb = ST(3);
	SV *	cb = ST(4);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1355 "EV.xs"
        CHECK_REPEAT (interval);
#line 3997 "EV.c"
#line 1357 "EV.xs"
{
  	ev_periodic *w;
        w = e_new (sizeof (ev_periodic), cb, ST (0));
        w->fh = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;
        ev_periodic_set (w, at, interval, w->fh ? e_periodic_cb : 0);
        RETVAL = e_bless ((ev_watcher *)w, stash_periodic);
        if (!ix) START (periodic, w);
}
#line 4007 "EV.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if 0
#define XSubPPtmpAAAB 1


XS(XS_EV__Loop_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, signal, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_signal *	RETVAL;
	struct ev_loop *	loop;
	SV *	signal = ST(1);
	SV *	cb = ST(2);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1374 "EV.xs"
{
  	Signal signum = sv_signum (signal);
        CHECK_SIG (signal, signum);

        RETVAL = e_new (sizeof (ev_signal), cb, ST (0));
        ev_signal_set (RETVAL, signum);
        if (!ix) START (signal, RETVAL);
}
#line 4049 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_signal);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif

XS(XS_EV__Loop_idle); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_idle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_idle *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1391 "EV.xs"
        RETVAL = e_new (sizeof (ev_idle), cb, ST (0));
        ev_idle_set (RETVAL);
        if (!ix) START (idle, RETVAL);
#line 4085 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_idle);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_prepare); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_prepare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_prepare *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1401 "EV.xs"
        RETVAL = e_new (sizeof (ev_prepare), cb, ST (0));
        ev_prepare_set (RETVAL);
        if (!ix) START (prepare, RETVAL);
#line 4120 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_prepare);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_check *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1411 "EV.xs"
        RETVAL = e_new (sizeof (ev_check), cb, ST (0));
        ev_check_set (RETVAL);
        if (!ix) START (check, RETVAL);
#line 4155 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_check);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_fork); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_fork)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_fork *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1421 "EV.xs"
        RETVAL = e_new (sizeof (ev_fork), cb, ST (0));
        ev_fork_set (RETVAL);
        if (!ix) START (fork, RETVAL);
#line 4190 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_fork);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_child); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_child)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, pid, trace, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_child *	RETVAL;
	struct ev_loop *	loop;
	int	pid = (int)SvIV(ST(1));
	int	trace = (int)SvIV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1431 "EV.xs"
        RETVAL = e_new (sizeof (ev_child), cb, ST (0));
        ev_child_set (RETVAL, pid, trace);
        if (!ix) START (child, RETVAL);
#line 4227 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_child);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, path, interval, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_stat *	RETVAL;
	struct ev_loop *	loop;
	SV *	path = ST(1);
	NV	interval = (NV)SvNV(ST(2));
	SV *	cb = ST(3);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1441 "EV.xs"
        RETVAL = e_new (sizeof (ev_stat), cb, ST (0));
        RETVAL->fh = newSVsv (path);
        ev_stat_set (RETVAL, SvPVbyte_nolen (RETVAL->fh), interval);
        if (!ix) START (stat, RETVAL);
#line 4265 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_stat);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_embed); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_embed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, other, cb= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_embed *	RETVAL;
	struct ev_loop *	loop;
	struct ev_loop *	other;
	SV *	cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));

	if (!(SvROK (ST(1)) && SvOBJECT (SvRV (ST(1)))
              && (SvSTASH (SvRV (ST(1))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	other = (struct ev_loop *)SvIVX (SvRV (ST(1)));

	if (items < 3)
	    cb = 0;
	else {
	    cb = ST(2);
	}
#line 1452 "EV.xs"
{
        if (!(ev_backend (other) & ev_embeddable_backends ()))
          croak ("passed loop is not embeddable via EV::embed,");

        RETVAL = e_new (sizeof (ev_embed), cb, ST (0));
        RETVAL->fh = newSVsv (ST (1));
        ev_embed_set (RETVAL, other);
        if (!ix) START (embed, RETVAL);
}
#line 4318 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_embed);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_async); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_async)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "loop, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	ev_async *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1468 "EV.xs"
        RETVAL = e_new (sizeof (ev_async), cb, ST (0));
        ev_async_set (RETVAL);
        if (!ix) START (async, RETVAL);
#line 4353 "EV.c"
	ST(0) = e_bless ((struct ev_watcher *)RETVAL, stash_async);


	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_EV__Loop_once); /* prototype to pass -Wmissing-prototypes */
XS(XS_EV__Loop_once)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "EV::Loop::once", "loop, fh, events, timeout, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct ev_loop *	loop;
	SV *	fh = ST(1);
	int	events = (int)SvIV(ST(2));
	SV *	timeout = ST(3);
	SV *	cb = ST(4);

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop)))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)));
#line 1476 "EV.xs"
        ev_once (
           loop,
           sv_fileno (fh), events,
           SvOK (timeout) ? SvNV (timeout) : -1.,
           e_once_cb,
           newSVsv (cb)
        );
#line 4393 "EV.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_EV); /* prototype to pass -Wmissing-prototypes */
XS(boot_EV)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("EV::default_loop", XS_EV_default_loop, file, ";$");
        newXSproto("EV::default_destroy", XS_EV_default_destroy, file, "");
        newXSproto("EV::supported_backends", XS_EV_supported_backends, file, "");
        newXSproto("EV::recommended_backends", XS_EV_recommended_backends, file, "");
        newXSproto("EV::embeddable_backends", XS_EV_embeddable_backends, file, "");
        newXSproto("EV::sleep", XS_EV_sleep, file, "$");
        newXSproto("EV::time", XS_EV_time, file, "");
        newXSproto("EV::now", XS_EV_now, file, "");
        newXSproto("EV::now_update", XS_EV_now_update, file, "");
        newXSproto("EV::suspend", XS_EV_suspend, file, "");
        newXSproto("EV::resume", XS_EV_resume, file, "");
        newXSproto("EV::backend", XS_EV_backend, file, "");
        newXSproto("EV::loop_count", XS_EV_loop_count, file, "");
        newXSproto("EV::set_io_collect_interval", XS_EV_set_io_collect_interval, file, "$");
        newXSproto("EV::set_timeout_collect_interval", XS_EV_set_timeout_collect_interval, file, "$");
        newXSproto("EV::loop", XS_EV_loop, file, ";$");
        newXSproto("EV::unloop", XS_EV_unloop, file, ";$");
        newXSproto("EV::feed_fd_event", XS_EV_feed_fd_event, file, "$;$");
        newXSproto("EV::feed_signal_event", XS_EV_feed_signal_event, file, "$");
        cv = newXS("EV::io", XS_EV_io, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::io_ns", XS_EV_io, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::timer_ns", XS_EV_timer, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::timer", XS_EV_timer, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::periodic_ns", XS_EV_periodic, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$$") ;
        cv = newXS("EV::periodic", XS_EV_periodic, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$$") ;
        cv = newXS("EV::signal_ns", XS_EV_signal, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$") ;
        cv = newXS("EV::signal", XS_EV_signal, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$") ;
        cv = newXS("EV::idle_ns", XS_EV_idle, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::idle", XS_EV_idle, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::prepare", XS_EV_prepare, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::prepare_ns", XS_EV_prepare, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::check", XS_EV_check, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::check_ns", XS_EV_check, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::fork", XS_EV_fork, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::fork_ns", XS_EV_fork, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::child_ns", XS_EV_child, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::child", XS_EV_child, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::stat_ns", XS_EV_stat, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::stat", XS_EV_stat, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$$") ;
        cv = newXS("EV::embed", XS_EV_embed, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("EV::embed_ns", XS_EV_embed, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("EV::async", XS_EV_async, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$") ;
        cv = newXS("EV::async_ns", XS_EV_async, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$") ;
        newXSproto("EV::once", XS_EV_once, file, "$$$$");
        newXS("EV::Watcher::is_active", XS_EV__Watcher_is_active, file);
        newXS("EV::Watcher::is_pending", XS_EV__Watcher_is_pending, file);
        newXS("EV::Watcher::invoke", XS_EV__Watcher_invoke, file);
        newXS("EV::Watcher::clear_pending", XS_EV__Watcher_clear_pending, file);
        newXS("EV::Watcher::feed_event", XS_EV__Watcher_feed_event, file);
        newXS("EV::Watcher::keepalive", XS_EV__Watcher_keepalive, file);
        newXS("EV::Watcher::cb", XS_EV__Watcher_cb, file);
        newXS("EV::Watcher::data", XS_EV__Watcher_data, file);
        newXS("EV::Watcher::loop", XS_EV__Watcher_loop, file);
        newXS("EV::Watcher::priority", XS_EV__Watcher_priority, file);
        newXS("EV::IO::start", XS_EV__IO_start, file);
        newXS("EV::IO::stop", XS_EV__IO_stop, file);
        newXS("EV::IO::DESTROY", XS_EV__IO_DESTROY, file);
        newXS("EV::IO::set", XS_EV__IO_set, file);
        newXS("EV::IO::fh", XS_EV__IO_fh, file);
        newXS("EV::IO::events", XS_EV__IO_events, file);
        newXS("EV::Signal::start", XS_EV__Signal_start, file);
        newXS("EV::Signal::stop", XS_EV__Signal_stop, file);
        newXS("EV::Signal::DESTROY", XS_EV__Signal_DESTROY, file);
        newXS("EV::Signal::set", XS_EV__Signal_set, file);
        newXS("EV::Signal::signal", XS_EV__Signal_signal, file);
        newXS("EV::Timer::start", XS_EV__Timer_start, file);
        newXS("EV::Timer::stop", XS_EV__Timer_stop, file);
        newXS("EV::Timer::again", XS_EV__Timer_again, file);
        newXS("EV::Timer::DESTROY", XS_EV__Timer_DESTROY, file);
        newXS("EV::Timer::set", XS_EV__Timer_set, file);
        newXS("EV::Periodic::start", XS_EV__Periodic_start, file);
        newXS("EV::Periodic::stop", XS_EV__Periodic_stop, file);
        newXS("EV::Periodic::again", XS_EV__Periodic_again, file);
        newXS("EV::Periodic::DESTROY", XS_EV__Periodic_DESTROY, file);
        newXS("EV::Periodic::set", XS_EV__Periodic_set, file);
        newXS("EV::Periodic::at", XS_EV__Periodic_at, file);
        newXS("EV::Idle::start", XS_EV__Idle_start, file);
        newXS("EV::Idle::stop", XS_EV__Idle_stop, file);
        newXS("EV::Idle::DESTROY", XS_EV__Idle_DESTROY, file);
        newXS("EV::Prepare::start", XS_EV__Prepare_start, file);
        newXS("EV::Prepare::stop", XS_EV__Prepare_stop, file);
        newXS("EV::Prepare::DESTROY", XS_EV__Prepare_DESTROY, file);
        newXS("EV::Check::start", XS_EV__Check_start, file);
        newXS("EV::Check::stop", XS_EV__Check_stop, file);
        newXS("EV::Check::DESTROY", XS_EV__Check_DESTROY, file);
        newXS("EV::Fork::start", XS_EV__Fork_start, file);
        newXS("EV::Fork::stop", XS_EV__Fork_stop, file);
        newXS("EV::Fork::DESTROY", XS_EV__Fork_DESTROY, file);
        newXS("EV::Child::start", XS_EV__Child_start, file);
        newXS("EV::Child::stop", XS_EV__Child_stop, file);
        newXS("EV::Child::DESTROY", XS_EV__Child_DESTROY, file);
        newXS("EV::Child::set", XS_EV__Child_set, file);
        cv = newXS("EV::Child::pid", XS_EV__Child_pid, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Child::rstatus", XS_EV__Child_pid, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("EV::Child::rpid", XS_EV__Child_pid, file);
        XSANY.any_i32 = 1 ;
        newXS("EV::Stat::start", XS_EV__Stat_start, file);
        newXS("EV::Stat::stop", XS_EV__Stat_stop, file);
        newXS("EV::Stat::DESTROY", XS_EV__Stat_DESTROY, file);
        newXS("EV::Stat::set", XS_EV__Stat_set, file);
        newXS("EV::Stat::path", XS_EV__Stat_path, file);
        newXS("EV::Stat::interval", XS_EV__Stat_interval, file);
        cv = newXS("EV::Stat::prev", XS_EV__Stat_prev, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Stat::stat", XS_EV__Stat_prev, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Stat::attr", XS_EV__Stat_prev, file);
        XSANY.any_i32 = 2 ;
        newXS("EV::Embed::start", XS_EV__Embed_start, file);
        newXS("EV::Embed::stop", XS_EV__Embed_stop, file);
        newXS("EV::Embed::DESTROY", XS_EV__Embed_DESTROY, file);
        newXS("EV::Embed::set", XS_EV__Embed_set, file);
        newXS("EV::Embed::other", XS_EV__Embed_other, file);
        newXS("EV::Embed::sweep", XS_EV__Embed_sweep, file);
        newXS("EV::Async::start", XS_EV__Async_start, file);
        newXS("EV::Async::stop", XS_EV__Async_stop, file);
        newXS("EV::Async::DESTROY", XS_EV__Async_DESTROY, file);
        newXS("EV::Async::send", XS_EV__Async_send, file);
        newXS("EV::Async::async_pending", XS_EV__Async_async_pending, file);
        newXS("EV::Loop::new", XS_EV__Loop_new, file);
        newXS("EV::Loop::DESTROY", XS_EV__Loop_DESTROY, file);
        newXS("EV::Loop::loop_fork", XS_EV__Loop_loop_fork, file);
        newXS("EV::Loop::loop_verify", XS_EV__Loop_loop_verify, file);
        newXS("EV::Loop::now", XS_EV__Loop_now, file);
        newXS("EV::Loop::now_update", XS_EV__Loop_now_update, file);
        newXS("EV::Loop::suspend", XS_EV__Loop_suspend, file);
        newXS("EV::Loop::resume", XS_EV__Loop_resume, file);
        newXS("EV::Loop::set_io_collect_interval", XS_EV__Loop_set_io_collect_interval, file);
        newXS("EV::Loop::set_timeout_collect_interval", XS_EV__Loop_set_timeout_collect_interval, file);
        newXS("EV::Loop::backend", XS_EV__Loop_backend, file);
        newXS("EV::Loop::loop_count", XS_EV__Loop_loop_count, file);
        newXS("EV::Loop::loop", XS_EV__Loop_loop, file);
        newXS("EV::Loop::unloop", XS_EV__Loop_unloop, file);
        newXS("EV::Loop::feed_fd_event", XS_EV__Loop_feed_fd_event, file);
#if XSubPPtmpAAAA
        newXS("EV::Loop::feed_signal_event", XS_EV__Loop_feed_signal_event, file);
#endif
        cv = newXS("EV::Loop::io_ns", XS_EV__Loop_io, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::io", XS_EV__Loop_io, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::timer", XS_EV__Loop_timer, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::timer_ns", XS_EV__Loop_timer, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::periodic", XS_EV__Loop_periodic, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::periodic_ns", XS_EV__Loop_periodic, file);
        XSANY.any_i32 = 1 ;
#if XSubPPtmpAAAB
        cv = newXS("EV::Loop::signal_ns", XS_EV__Loop_signal, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::signal", XS_EV__Loop_signal, file);
        XSANY.any_i32 = 0 ;
#endif
        cv = newXS("EV::Loop::idle", XS_EV__Loop_idle, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::idle_ns", XS_EV__Loop_idle, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::prepare", XS_EV__Loop_prepare, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::prepare_ns", XS_EV__Loop_prepare, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::check", XS_EV__Loop_check, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::check_ns", XS_EV__Loop_check, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::fork", XS_EV__Loop_fork, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::fork_ns", XS_EV__Loop_fork, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::child_ns", XS_EV__Loop_child, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::child", XS_EV__Loop_child, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::stat", XS_EV__Loop_stat, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::stat_ns", XS_EV__Loop_stat, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::embed", XS_EV__Loop_embed, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::embed_ns", XS_EV__Loop_embed, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("EV::Loop::async", XS_EV__Loop_async, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("EV::Loop::async_ns", XS_EV__Loop_async, file);
        XSANY.any_i32 = 1 ;
        newXS("EV::Loop::once", XS_EV__Loop_once, file);
    }

    /* Initialisation Section */

#line 391 "EV.xs"
{
  HV *stash = gv_stashpv ("EV", 1);

  static const struct {
    const char *name;
    IV iv;
  } *civ, const_iv[] = {
#   define const_iv(pfx, name) { # name, (IV) pfx ## name },
    const_iv (EV_, MINPRI)
    const_iv (EV_, MAXPRI)

    const_iv (EV_, UNDEF)
    const_iv (EV_, NONE)
    const_iv (EV_, READ)
    const_iv (EV_, WRITE)
    const_iv (EV_, IO)
    const_iv (EV_, TIMEOUT)
    const_iv (EV_, TIMER)
    const_iv (EV_, PERIODIC)
    const_iv (EV_, SIGNAL)
    const_iv (EV_, CHILD)
    const_iv (EV_, STAT)
    const_iv (EV_, IDLE)
    const_iv (EV_, PREPARE)
    const_iv (EV_, CHECK)
    const_iv (EV_, EMBED)
    const_iv (EV_, FORK)
    const_iv (EV_, ASYNC)
    const_iv (EV_, CUSTOM)
    const_iv (EV_, ERROR)

    const_iv (EV, LOOP_NONBLOCK)
    const_iv (EV, LOOP_ONESHOT)

    const_iv (EV, UNLOOP_CANCEL)
    const_iv (EV, UNLOOP_ONE)
    const_iv (EV, UNLOOP_ALL)

    const_iv (EV, BACKEND_SELECT)
    const_iv (EV, BACKEND_POLL)
    const_iv (EV, BACKEND_EPOLL)
    const_iv (EV, BACKEND_KQUEUE)
    const_iv (EV, BACKEND_DEVPOLL)
    const_iv (EV, BACKEND_PORT)
    const_iv (EV, FLAG_AUTO)
    const_iv (EV, FLAG_NOENV)
    const_iv (EV, FLAG_FORKCHECK)

    const_iv (EV_, VERSION_MAJOR)
    const_iv (EV_, VERSION_MINOR)
  };

  for (civ = const_iv + sizeof (const_iv) / sizeof (const_iv [0]); civ-- > const_iv; )
    newCONSTSUB (stash, (char *)civ->name, newSViv (civ->iv));

  stash_loop     = gv_stashpv ("EV::Loop"    , 1);
  stash_watcher  = gv_stashpv ("EV::Watcher" , 1);
  stash_io       = gv_stashpv ("EV::IO"      , 1);
  stash_timer    = gv_stashpv ("EV::Timer"   , 1);
  stash_periodic = gv_stashpv ("EV::Periodic", 1);
  stash_signal   = gv_stashpv ("EV::Signal"  , 1);
  stash_idle     = gv_stashpv ("EV::Idle"    , 1);
  stash_prepare  = gv_stashpv ("EV::Prepare" , 1);
  stash_check    = gv_stashpv ("EV::Check"   , 1);
  stash_child    = gv_stashpv ("EV::Child"   , 1);
  stash_embed    = gv_stashpv ("EV::Embed"   , 1);
  stash_stat     = gv_stashpv ("EV::Stat"    , 1);
  stash_fork     = gv_stashpv ("EV::Fork"    , 1);
  stash_async    = gv_stashpv ("EV::Async"   , 1);

  {
    SV *sv = perl_get_sv ("EV::API", TRUE);
             perl_get_sv ("EV::API", TRUE); /* silence 5.10 warning */

    /* the poor man's shared library emulator */
    evapi.ver                  = EV_API_VERSION;
    evapi.rev                  = EV_API_REVISION;
    evapi.sv_fileno            = sv_fileno;
    evapi.sv_signum            = sv_signum;
    evapi.supported_backends   = ev_supported_backends ();
    evapi.recommended_backends = ev_recommended_backends ();
    evapi.embeddable_backends  = ev_embeddable_backends ();
    evapi.time_                = ev_time;
    evapi.sleep_               = ev_sleep;
    evapi.loop_new             = ev_loop_new;
    evapi.loop_destroy         = ev_loop_destroy;
    evapi.loop_fork            = ev_loop_fork;
    evapi.loop_count           = ev_loop_count;
    evapi.now                  = ev_now;
    evapi.now_update           = ev_now_update;
    evapi.suspend              = ev_suspend;
    evapi.resume               = ev_resume;
    evapi.backend              = ev_backend;
    evapi.unloop               = ev_unloop;
    evapi.ref                  = ev_ref;
    evapi.unref                = ev_unref;
    evapi.loop                 = ev_loop;
    evapi.once                 = ev_once;
    evapi.io_start             = ev_io_start;
    evapi.io_stop              = ev_io_stop;
    evapi.timer_start          = ev_timer_start;
    evapi.timer_stop           = ev_timer_stop;
    evapi.timer_again          = ev_timer_again;
    evapi.periodic_start       = ev_periodic_start;
    evapi.periodic_stop        = ev_periodic_stop;
    evapi.signal_start         = ev_signal_start;
    evapi.signal_stop          = ev_signal_stop;
    evapi.idle_start           = ev_idle_start;
    evapi.idle_stop            = ev_idle_stop;
    evapi.prepare_start        = ev_prepare_start;
    evapi.prepare_stop         = ev_prepare_stop;
    evapi.check_start          = ev_check_start;
    evapi.check_stop           = ev_check_stop;
    evapi.child_start          = ev_child_start;
    evapi.child_stop           = ev_child_stop;
    evapi.stat_start           = ev_stat_start;
    evapi.stat_stop            = ev_stat_stop;
    evapi.stat_stat            = ev_stat_stat;
    evapi.embed_start          = ev_embed_start;
    evapi.embed_stop           = ev_embed_stop;
    evapi.embed_sweep          = ev_embed_sweep;
    evapi.fork_start           = ev_fork_start;
    evapi.fork_stop            = ev_fork_stop;
    evapi.async_start          = ev_async_start;
    evapi.async_stop           = ev_async_stop;
    evapi.async_send           = ev_async_send;
    evapi.clear_pending        = ev_clear_pending;
    evapi.invoke               = ev_invoke;

    sv_setiv (sv, (IV)&evapi);
    SvREADONLY_on (sv);
  }
#ifndef _WIN32
  pthread_atfork (0, 0, ev_default_fork);
#endif
}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 4802 "EV.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

